package p1;
//@JPLAS test
import static org.junit.Assert.*;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.*;
import java.nio.file.CopyOption;

import org.junit.Test;

import report.Report;

public class AnimalTest {

	@Test
	public void test() throws NoSuchMethodException, SecurityException {
		Animal a=new Animal();
		
		//check the methods in animal class
		Method m1=a.getClass().getDeclaredMethod("testClassMethod",(Class[])null);
		assertEquals(m1.getModifiers(),Modifier.PUBLIC, Modifier.STATIC);
		assertEquals(m1.getReturnType(),void.class);
		//check the methods in animal class
		Method m2=a.getClass().getDeclaredMethod("testInstanceMethod",(Class[])null);
		assertEquals(m2.getModifiers(),Modifier.PUBLIC);
		assertEquals(m2.getReturnType(),void.class);
		//Check the number of methods in Animal Class
		Method[] Amethods=a.getClass().getDeclaredMethods();
		assertEquals(2,Amethods.length);
		
		Cat c=new Cat();
	    Class<?> parentClass = c.getClass().getSuperclass();

		//check the methods in animal (super) class
	    Method m3=parentClass.getDeclaredMethod("testClassMethod",(Class[])null);
	    Method m4=parentClass.getDeclaredMethod("testInstanceMethod",(Class[])null);
		//check the overwriting methods in Cat (sub) class
		Method m5=c.getClass().getDeclaredMethod("testClassMethod",(Class[])null);
		assertEquals(m5.getModifiers(),Modifier.PUBLIC, Modifier.STATIC);
		assertEquals(m5.getReturnType(),void.class);
		Method m6=c.getClass().getDeclaredMethod("testInstanceMethod",(Class[])null);
		assertEquals(m6.getModifiers(),Modifier.PUBLIC);
		assertEquals(m6.getReturnType(),void.class);
		//check the number of methods in Cat class
		Method[] Cmethods=c.getClass().getDeclaredMethods();
		assertEquals(2,Cmethods.length);	
	}
	
	@Test
	public void test1() throws IOException{
		Cat myCat = new Cat();
		Animal myAnimal = myCat;
		ByteArrayOutputStream outContent = new ByteArrayOutputStream();
		System.setOut(new PrintStream(outContent));
	    Animal.testClassMethod();//method
	    assertEquals("The static method in Animal",outContent.toString());
	    ByteArrayOutputStream outContent1 = new ByteArrayOutputStream();
	    System.setOut(new PrintStream(outContent1));
	    myAnimal.testInstanceMethod();//method
	    assertEquals("The instance method in Cat",outContent1.toString());
	}
	
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
}


