package p11;
//@JPLAS test
import static org.junit.Assert.*;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Assert;
import org.junit.Test;

import report.Report;
public class MethodOverloadingTest {
	
	

	@Test
	public void specTest() throws ReflectiveOperationException, SecurityException, NoSuchMethodException, Exception {
		MethodOverloading mol = new MethodOverloading();
		// check method name
		Method m1 = mol.getClass().getDeclaredMethod("average", int.class, int.class);// method 1
		Method m2 = mol.getClass().getDeclaredMethod("average", double.class, double.class);// method 2
		Method m3 = mol.getClass().getDeclaredMethod("average", int.class, int.class, int.class);// method 3

		// check the number of variables in author class.
		Method[] m = mol.getClass().getDeclaredMethods();
		assertEquals(3, m.length);
		
		// check modifier name
		assertEquals(m1.getModifiers(), Modifier.PUBLIC, Modifier.STATIC);
		assertEquals(m2.getModifiers(), Modifier.PUBLIC, Modifier.STATIC);
		assertEquals(m3.getModifiers(), Modifier.PUBLIC, Modifier.STATIC);
		

		// check data type for each Method
		assertEquals(m1.getReturnType(), int.class);
		assertEquals(m2.getReturnType(), double.class);
		assertEquals(m3.getReturnType(), int.class);

	}
	
	@Test
	// check the behaviors of method and variables
	public void behavTest() throws RuntimeException, ReflectiveOperationException {
		int actual1=MethodOverloading.average(1,2);
		assertEquals(1, actual1);
		
		double actual2=(double)MethodOverloading.average(1.0, 2.0);
		Assert.assertEquals(1.5, actual2,0.0);
		
		int actual3=MethodOverloading.average(1, 2, 3);
		assertEquals(2, actual3);
		
		double actual4=MethodOverloading.average(1.0, 2);
		Assert.assertEquals(1.5, actual4,0.0);
		
	}
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}

}
