package p12;
//@JPLAS test
import static org.junit.Assert.*;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Assert;
import org.junit.Test;

import report.Report;

public class PhysicsTeacherTest {
	@Test
	public void specTest() throws NoSuchMethodException, NoSuchFieldException {

		// construct an object
		PhysicsTeacher phyTeacher = new PhysicsTeacher();
		Class<?> parentClass = phyTeacher.getClass().getSuperclass();

		// check the variable name in parent class
		Field f1 = parentClass.getDeclaredField("designation");
		Field f2 = parentClass.getDeclaredField("collegeName");

		// check the modifier name in parent class
		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
		assertEquals(f2.getModifiers(), Modifier.PRIVATE);

		// check data type for each variable
		assertEquals(f1.getType(), String.class);
		assertEquals(f2.getType(), String.class);

		// check the methods name in parent class
		Method m1 = parentClass.getDeclaredMethod("getDesignation", (Class[])null);
		Method m2 = parentClass.getDeclaredMethod("setDesignation", String.class);
		Method m3 = parentClass.getDeclaredMethod("getCollegeName", (Class[])null);
		Method m4 = parentClass.getDeclaredMethod("setCollegeName", String.class);
		Method m5 = parentClass.getDeclaredMethod("display", (Class[])null);

		// check method modifier in parent class
		assertEquals(m1.getModifiers(), Modifier.PUBLIC);
		assertEquals(m2.getModifiers(), Modifier.PROTECTED);
		assertEquals(m3.getModifiers(), Modifier.PROTECTED);
		assertEquals(m4.getModifiers(), Modifier.PROTECTED);
		assertEquals(m5.getModifiers(),Modifier.PUBLIC);

		// check data type for each method in parent class
		assertEquals(m1.getReturnType(), String.class);
		assertEquals(m2.getReturnType(), void.class);
		assertEquals(m3.getReturnType(), String.class);
		assertEquals(m4.getReturnType(), void.class);
		assertEquals(m5.getReturnType(), String.class);

		// check the variable name in sub class
		Field subf1 = phyTeacher.getClass().getDeclaredField("mainSubject");
		assertEquals(subf1.getModifiers(), Modifier.PRIVATE);
		assertEquals(subf1.getType(), String.class);

		// check data type for each variable
		assertEquals(subf1.getType(), String.class);
	}

	@Test
	public void behavTest() throws ReflectiveOperationException, RuntimeException {
		// check behavior of superclass's methods
		
		// construct an object
		PhysicsTeacher phyTeacher = new PhysicsTeacher();
		Class<?> parentClass = phyTeacher.getClass().getSuperclass();
	    
            
		// Declare Field in parent class
		Field f1 = parentClass.getDeclaredField("designation");
		Field f2 = parentClass.getDeclaredField("collegeName");
		Field f3 = PhysicsTeacher.class.getDeclaredField("mainSubject");
		f1.setAccessible(true);
		f2.setAccessible(true);
		f3.setAccessible(true);
		
		// check behavior of subclass's methods
		String data=phyTeacher.display();
				
		// check the value of variables
		String designation = (String) f1.get(phyTeacher);
		String collegeName = (String) f2.get(phyTeacher);
		String mainSubject = (String) f3.get(phyTeacher);
		//check the behaviors of set method
				
		assertEquals("Teacher", designation);
		assertEquals("Education", collegeName);
		assertEquals("Teacher\tEducation", data);
		assertEquals("Physics",mainSubject);
	
        }
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
	}

