package p4;
//@JPLAS test
import static org.junit.Assert.*;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import org.junit.Test;

import report.Report;

public class AuthorTest {

	@Test
	public void specTest() throws NoSuchMethodException, NoSuchFieldException {
		// construct author object
		Author author = new Author("Tan Ah Teck", "teck@nowhere.com", 'm');
		// check the variable name
		Field f1 = author.getClass().getDeclaredField("name");// variable 1
		Field f2 = author.getClass().getDeclaredField("email");// variable 2
		Field f3 = author.getClass().getDeclaredField("gender");// variable 3

		// check the modifier name
		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
		assertEquals(f2.getModifiers(), Modifier.PRIVATE);
		assertEquals(f3.getModifiers(), Modifier.PRIVATE);
		
		//check data type for each variable
		assertEquals(f1.getType(),String.class);
		assertEquals(f2.getType(),String.class);
		assertEquals(f3.getType(), char.class);
		
		//check the number of variables in Author class. 
		Method[] m=author.getClass().getDeclaredMethods();
		assertEquals(5, m.length);
		
		//check method name
		Method m1 = author.getClass().getDeclaredMethod("getName", (Class[])null);//method 1
		Method m2 = author.getClass().getDeclaredMethod("getGender",(Class[])null); //method 2
		Method m3 = author.getClass().getDeclaredMethod("getEmail",(Class[])null);//method 3
		Method m4 = author.getClass().getDeclaredMethod("setEmail", String.class);//method 4
		Method m5 = author.getClass().getDeclaredMethod("toString",(Class[])null);//method 5
		
		//check modifier name
	    assertEquals(m1.getModifiers(),Modifier.PUBLIC);
	    assertEquals(m2.getModifiers(),Modifier.PUBLIC);
        assertEquals(m3.getModifiers(),Modifier.PUBLIC);
        assertEquals(m4.getModifiers(),Modifier.PUBLIC);
        assertEquals(m5.getModifiers(),Modifier.PUBLIC);
		
        //check data type for each Method
        assertEquals(m1.getReturnType(),String.class);
        assertEquals(m2.getReturnType(),char.class);
        assertEquals(m3.getReturnType(),String.class);
        assertEquals(m4.getReturnType(),void.class);
        assertEquals(m5.getReturnType(),String.class);
	}
	@Test
	//check the behaviors of method and variables
	public void behavTest() throws RuntimeException, ReflectiveOperationException {
		// construct author object
		Author author = new Author("Tan Ah Teck", "teck@nowhere.com", 'm');
		
		// check the variable name
		Field f1 = author.getClass().getDeclaredField("name");// variable 1
		Field f2 = author.getClass().getDeclaredField("email");// variable 2
		Field f3 = author.getClass().getDeclaredField("gender");// variable 3
		f1.setAccessible(true);
		f2.setAccessible(true);
		f3.setAccessible(true);
		
		//check the behaviors of set method
		author.getName();
		author.getEmail();
		author.getGender();
		author.toString();
	
		//check the value of variables 
		String name=(String) f1.get(author);
		String email=(String)f2.get(author);
		char gender=(char)f3.get(author);
		assertEquals("Tan Ah Teck",name);
		assertEquals("teck@nowhere.com",email);
		assertEquals('m',gender);
		
		//check the behaviors of set method
	    author.setEmail("teck@somewhere.com");
	    String updatedEmail=(String)f2.get(author);
	    assertEquals("Tan Ah Teck",name);
		assertEquals("teck@somewhere.com",updatedEmail);
		assertEquals('m',gender);		
	}
	
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
}

