package p4;
//@JPLAS test
import static org.junit.Assert.*;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Test;

import report.Report;

public class BookTest {
	@Test
	public void specTest() throws ReflectiveOperationException, RuntimeException {

		// Test Book's constructor and toString()
		Book dummyBook = new Book("Java for dummies", "Tan Ah Teck", 9.99, 99);
		// check the variable name
		Field f1 = dummyBook.getClass().getDeclaredField("name");// variable 1
		Field f2 = dummyBook.getClass().getDeclaredField("author");// variable 2
		Field f3 = dummyBook.getClass().getDeclaredField("price");// variable 3
		Field f4 = dummyBook.getClass().getDeclaredField("qty");// variable 4

		// check the modifier name
		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
		assertEquals(f2.getModifiers(), Modifier.PRIVATE);
		assertEquals(f3.getModifiers(), Modifier.PRIVATE);
		assertEquals(f4.getModifiers(), Modifier.PRIVATE);

		// check data type for each variable
		assertEquals(f1.getType(), String.class);
		assertEquals(f2.getType(), String.class);
		assertEquals(f3.getType(), double.class);
		assertEquals(f4.getType(), int.class);

		// check method name
		Method m1 = dummyBook.getClass().getDeclaredMethod("getName", (Class[])null);// method 1
		Method m2 = dummyBook.getClass().getDeclaredMethod("getAuthor", (Class[])null); // method 2
		Method m3 = dummyBook.getClass().getDeclaredMethod("getPrice", (Class[])null);// method 3
		Method m4 = dummyBook.getClass().getDeclaredMethod("setPrice", double.class);// method 4
		Method m5 = dummyBook.getClass().getDeclaredMethod("getQty", (Class[])null);// method 5
		Method m6 = dummyBook.getClass().getDeclaredMethod("setQty", int.class);// method 6
		Method m7 = dummyBook.getClass().getDeclaredMethod("toString", (Class[])null);// method 7

		// check the number of variables in author class.
		Method[] m = dummyBook.getClass().getDeclaredMethods();
		assertEquals(7, m.length);

		// check modifier name
		assertEquals(m1.getModifiers(), Modifier.PUBLIC);
		assertEquals(m2.getModifiers(), Modifier.PUBLIC);
		assertEquals(m3.getModifiers(), Modifier.PUBLIC);
		assertEquals(m4.getModifiers(), Modifier.PUBLIC);
		assertEquals(m5.getModifiers(), Modifier.PUBLIC);
		assertEquals(m6.getModifiers(), Modifier.PUBLIC);
		assertEquals(m7.getModifiers(), Modifier.PUBLIC);

		// check data type for each Method
		assertEquals(m1.getReturnType(), String.class);
		assertEquals(m2.getReturnType(), String.class);
		assertEquals(m3.getReturnType(), double.class);
		assertEquals(m4.getReturnType(), void.class);
		assertEquals(m5.getReturnType(), int.class);
		assertEquals(m6.getReturnType(), void.class);
		assertEquals(m7.getReturnType(), String.class);
	}

	
	@Test
	// check the behaviors of method and variables
	public void behavTest() throws RuntimeException, ReflectiveOperationException {
		// construct book object
		Book dummyBook = new Book("Java for dummies", "Tan Ah Teck", 9.99, 99);

		// check the variable name
		Field f1 = dummyBook.getClass().getDeclaredField("name");// variable 1
		Field f2 = dummyBook.getClass().getDeclaredField("author");// variable 2
		Field f3 = dummyBook.getClass().getDeclaredField("price");// variable 3
		Field f4 = dummyBook.getClass().getDeclaredField("qty");// variable 4
		f1.setAccessible(true);
		f2.setAccessible(true);
		f3.setAccessible(true);
		f4.setAccessible(true);
		
		//test the behavior of methods
		dummyBook.getName();
		dummyBook.getAuthor();
		dummyBook.getPrice();
		dummyBook.getQty();

		// check the value of variables
		String name = (String) f1.get(dummyBook);
		String author = (String) f2.get(dummyBook);
		double price = (double) f3.get(dummyBook);
		int qty = (int) f4.get(dummyBook);

		assertEquals("Java for dummies", name);
		assertEquals("Tan Ah Teck", author);
		assertEquals(9.99, price,0.0);
		assertEquals(99, qty);

		// check the behaviors of set method
		dummyBook.setPrice(8.5);
		dummyBook.setQty(100);

		assertEquals("Java for dummies", name);
		assertEquals("Tan Ah Teck", author);

	}
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}

}
