package p7;
//@JPLAS test
 import static org.junit.Assert.assertEquals;
 import java.lang.reflect.Constructor;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
 import java.lang.reflect.Modifier;
 import java.util.Iterator;
 import java.util.List;
 import org.junit.Test;

import report.Report;
 
 public class BookDataTest {
 	private int a;
 
 	@Test
 	public void variablesNameTest() throws NoSuchFieldException, SecurityException {
 		// construct an object
 		BookData bookDataObj = new BookData();
 		Book bookObj= new Book(101, "Let Us C", "Yashwant Kanetkar", "BPB", 8);
 		
 		// check the variable name of BookData class
 		Field f1 = bookDataObj.getClass().getDeclaredField("list");// variable 1
 		
 		// check the variable name of Book class
 		Field f2 = bookObj.getClass().getDeclaredField("id");// variable 2
 		Field f3 = bookObj.getClass().getDeclaredField("name");// variable 3
 		Field f4 = bookObj.getClass().getDeclaredField("author");// variable 4
 		Field f5 = bookObj.getClass().getDeclaredField("publisher");// variable 5
 		Field f6 = bookObj.getClass().getDeclaredField("quantity");// variable 6
 				
 		//check the number of variables in BookData class. 
 		Field[] bookDataField=bookDataObj.getClass().getDeclaredFields();
 		assertEquals(1, bookDataField.length);
 		
 		//check the number of variables in Book class. 
 		Field[] bookField=bookObj.getClass().getDeclaredFields();
 		assertEquals(5, bookField.length);
 		
 		// check the modifier name for field
 		assertEquals(f2.getModifiers(), Modifier.PROTECTED);
 		assertEquals(f3.getModifiers(), Modifier.PROTECTED);
 		assertEquals(f4.getModifiers(), Modifier.PROTECTED);
 		assertEquals(f5.getModifiers(), Modifier.PROTECTED);
 		assertEquals(f6.getModifiers(), Modifier.PROTECTED);
 		
 		// check data type for each variable
 		assertEquals(f2.getType(), int.class);
 		assertEquals(f3.getType(), String.class);
 		assertEquals(f4.getType(), String.class);
 		assertEquals(f5.getType(), String.class);
 		assertEquals(f6.getType(), int.class);
 		
 		//check data type for each variable
 		assertEquals(f1.getType(),List.class);
 	}
 	
 	@Test
 	public void methodsNameTest() throws NoSuchMethodException, SecurityException {
 			
 		// construct an object
 		BookData bookDataObj = new BookData();
 		Book bookObj= new Book(101, "Let Us C", "Yashwant Kanetkar", "BPB", 8);
 		
 		Constructor constructor[]= bookObj.getClass().getConstructors();
 		assertEquals(1, constructor.length);
 		
 		//check the number of variables in author class. 
 		Method[] m=bookDataObj.getClass().getDeclaredMethods();
 		assertEquals(2, m.length);
 		
 		//check the number of variables in Book class. 
 		Method[] mb=bookObj.getClass().getDeclaredMethods();
 		assertEquals(0, mb.length);
 		
 		//check method name
 		Method m1 = bookDataObj.getClass().getDeclaredMethod("addData", (Class[])null);//method 1
 		Method m2 = bookDataObj.getClass().getDeclaredMethod("removeData",(Class[])null); //method 2
 		
 		//check data type for each Method
         assertEquals(List.class, m1.getReturnType());
         assertEquals(List.class, m2.getReturnType());
 	}
 	
 	@Test
 	public void test2() {
 		// construct an object
 		BookData bookDataObj = new BookData();
 		List<Book> list = bookDataObj.addData();
 		assertEquals(3,list.size());
 		assertEquals(101+" Let Us C Yashwant Kanetkar BPB "+8, list.get(0).id+" " + list.get(0).name + " " + list.get(0).author + " " + list.get(0).publisher + " " + list.get(0).quantity);
 		assertEquals(103+" Operating System Galvin Wiley "+6, list.get(1).id+" " + list.get(1).name + " " + list.get(1).author + " " + list.get(1).publisher + " " + list.get(1).quantity);
 		assertEquals(102+" Data Communications & Networking Forouzan Mc Graw Hill "+4, list.get(2).id+" " + list.get(2).name + " " + list.get(2).author + " " + list.get(2).publisher + " " + list.get(2).quantity);
 	}
 	@Test
 	public void test3() {
 		// construct an object
 		BookData bookDataObj = new BookData();
 		List<Book> list = bookDataObj.addData();
 		bookDataObj.removeData();
 		assertEquals(2,list.size());
 		assertEquals(101+" Let Us C Yashwant Kanetkar BPB "+8, list.get(0).id+" " + list.get(0).name + " " + list.get(0).author + " " + list.get(0).publisher + " " + list.get(0).quantity);
 		assertEquals(102+" Data Communications & Networking Forouzan Mc Graw Hill "+4, list.get(1).id+" " + list.get(1).name + " " + list.get(1).author + " " + list.get(1).publisher + " " + list.get(1).quantity);
 	}
 	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
 }
 

