package p8;
//@JPLAS test
import static org.junit.Assert.*;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import org.junit.Test;

import report.Report;

public class CarTest {

	@Test
	public void test1() throws NoSuchFieldException, SecurityException, NoSuchMethodException {
		//Car class
		Car car=new Car();

		//variable name 
		Field f1= car.getClass().getDeclaredField("fuel");
		Field f2= car.getClass().getDeclaredField("migration");
		//variable access modifier
		assertEquals(f1.getModifiers(),Modifier.PRIVATE);
		assertEquals(f2.getModifiers(),Modifier.PRIVATE);
		//variable data type
		assertEquals(f1.getType(), int.class);
		assertEquals(f1.getType(), int.class);
		//number of variables
		Field[] fields=car.getClass().getDeclaredFields();
		assertEquals(2,fields.length);
		
		//methods name
		 Method m1=car.getClass().getDeclaredMethod("move",(Class[])null);
		 Method m2=car.getClass().getDeclaredMethod("supply",int.class);
		 //methods access modifier
		 assertEquals(m1.getModifiers(),Modifier.PUBLIC);
		 assertEquals(m2.getModifiers(),Modifier.PUBLIC);
		 //methods data type
		 assertEquals(m1.getReturnType(), void.class);
		 assertEquals(m2.getReturnType(), void.class);
		 //number of methods
		  Method[] methods=car.getClass().getDeclaredMethods();
		  assertEquals(2,methods.length);
		
	}
	
	@Test
	public void test2() throws NoSuchFieldException, SecurityException, NoSuchMethodException {
		//variable in parentclass
		Ambulance a=new Ambulance();
		Class<?> parentClass = a.getClass().getSuperclass();
		Field f1= parentClass.getDeclaredField("fuel");
		Field f2= parentClass.getDeclaredField("migration");
		
		//methods in parentclass
		 Method m1=parentClass.getDeclaredMethod("move",(Class[])null);
		 Method m2=parentClass.getDeclaredMethod("supply",int.class);
		 
		 //variable in Ambulance class
		 Field f3= a.getClass().getDeclaredField("number");
		 assertEquals(f3.getModifiers(),Modifier.PRIVATE);
		 assertEquals(f3.getType(),int.class);
		 
		//methods in Ambulance
		 Method m3=a.getClass().getDeclaredMethod("sevePeople",(Class[])null);
		 assertEquals(m3.getModifiers(),Modifier.PUBLIC);
		 assertEquals(m2.getReturnType(), void.class);
			 
	}
	
	@Test
	public void test3() throws NoSuchFieldException, SecurityException, IllegalArgumentException, IllegalAccessException {
		//check the behaviors of the methods car class
		Car c = new Car();
		Field f1= c.getClass().getDeclaredField("fuel");
		Field f2= c.getClass().getDeclaredField("migration");
		f1.setAccessible(true);
		f2.setAccessible(true);
		int fuel;
		int migration;
		
		c.supply(10);//method
		fuel=(int)f1.get(c);
		assertEquals(10,fuel);
		c.move();//method
	    migration=(int)f2.get(c);
	    fuel=(int)f1.get(c);
		assertEquals(1,migration);
		assertEquals(9,fuel);
		c.move();//method
		migration=(int)f2.get(c);
		fuel=(int)f1.get(c);
	    assertEquals(2,migration);
	    assertEquals(8,fuel);
	    ////check the behaviors of the methods ambulance class
	    
	    Ambulance a=new Ambulance();
	    Class<?> parentClass = a.getClass().getSuperclass();
	    Field f3= parentClass.getDeclaredField("fuel");
		Field f4= parentClass.getDeclaredField("migration");
		Field f5= a.getClass().getDeclaredField("number");
		int number;
		f3.setAccessible(true);
		f4.setAccessible(true);
		f5.setAccessible(true);
	    a.supply(10);//method
	    fuel=(int)f3.get(a);
	    assertEquals(10,fuel);
	    a.move(); //method
		migration=(int)f4.get(a);
		fuel=(int)f3.get(a);
		assertEquals(1,migration);
		assertEquals(9,fuel);
		a.sevePeople();//method
		number=(int)f5.get(a);
		assertEquals(119,number);
	}
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
}

