package p9;
//@JPLAS test
import static org.junit.Assert.*;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Test;

import report.Report;

public class CircleTest {
	Field f1;
	Field f2;

	@Test
	public void specTest() throws NoSuchMethodException, SecurityException, NoSuchFieldException {

		f1 = Circle.class.getDeclaredField("radius");// variable 1
		f2 = Circle.class.getDeclaredField("color");// variable 2

		// check the modifier name
		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
		assertEquals(f2.getModifiers(), Modifier.PRIVATE);

		// check data type for each variable
		assertEquals(f1.getType(), double.class);
		assertEquals(f2.getType(), String.class);

		// check method name
		Method m1 = Circle.class.getDeclaredMethod("getRadius", (Class[])null);// method 1
		Method m2 = Circle.class.getDeclaredMethod("getColor", (Class[])null);// method 2
		Method m3 = Circle.class.getDeclaredMethod("getArea", (Class[])null);// method 3

		// check the number of variables in author class.
		Method[] m = Circle.class.getDeclaredMethods();
		assertEquals(3, m.length);

		// check modifier name for each method
		assertEquals(m1.getModifiers(), Modifier.PUBLIC);
		assertEquals(m2.getModifiers(), Modifier.PUBLIC);
		assertEquals(m3.getModifiers(), Modifier.PUBLIC);

		// check data type for each Method
		assertEquals(m1.getReturnType(), double.class);
		assertEquals(m2.getReturnType(), String.class);
		assertEquals(m3.getReturnType(), double.class);
	}

	@Test
	// check the behaviors of method and variables
	public void behavTest() throws RuntimeException, ReflectiveOperationException {
		Circle c1 = new Circle(2.0, "blue");
		Circle c2 = new Circle(2.0);
		Circle c3 = new Circle();


		// check the variable name
		f1 = Circle.class.getDeclaredField("radius");// variable 1
		f2 = Circle.class.getDeclaredField("color");// variable 2

		f1.setAccessible(true);
		f2.setAccessible(true);

		// check the value of variables
		double rad;
		String col;
		int area;
		c1.getRadius();
		c1.getColor();
		area = (int) c1.getArea();
		System.out.println("area	" + area);
		rad = (double) f1.get(c1);
		col = (String) f2.get(c1);
		assertEquals(2.0, rad, 0.0);
		assertEquals("blue", col);
		assertEquals(12, area);

		c2.getRadius();
		c2.getColor();
		area = (int) c2.getArea();
		System.out.println("area	" + area);
		rad = (double) f1.get(c2);
		col = (String) f2.get(c2);
		assertEquals(2.0, rad, 0.0);
		assertEquals("red", col);
		assertEquals(12, area);

		c3.getRadius();
		c3.getColor();
		area = (int) c3.getArea();
		System.out.println("area	" + area);
		rad = (double) f1.get(c3);
		col = (String) f2.get(c3);
		assertEquals(1.0, rad, 0.0);
		assertEquals("red", col);
		assertEquals(3, area);

	}
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
}


